searchNodes=[{"doc":"Functions to calculate multimedia track bandwidth according to: https://datatracker.ietf.org/doc/html/rfc8216#section-4.3.4.2","ref":"Membrane.HTTPAdaptiveStream.BandwidthCalculator.html","title":"Membrane.HTTPAdaptiveStream.BandwidthCalculator","type":"module"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.BandwidthCalculator.html#calculate_bandwidth/1","title":"Membrane.HTTPAdaptiveStream.BandwidthCalculator.calculate_bandwidth/1","type":"function"},{"doc":"Sink for generating HTTP streaming manifests. Uses Membrane.HTTPAdaptiveStream.Manifest for manifest serialization and Membrane.HTTPAdaptiveStream.Storage for saving files. Notifications {:track_playable, input_pad_id} - sent when the first segment of a track is stored, and thus the track is ready to be played Examples The following configuration: % Membrane.HTTPAdaptiveStream.Sink { manifest_name : &quot;manifest&quot; , manifest_module : Membrane.HTTPAdaptiveStream.HLS , storage : % Membrane.HTTPAdaptiveStream.Storages.FileStorage { directory : &quot;output&quot; } } will generate a HLS manifest in the output directory, playable from output/manifest.m3u8 file. Element options Passed via struct Membrane.HTTPAdaptiveStream.Sink.t/0 manifest_name String . t ( ) Default value: &quot;index&quot; Name of the main manifest file. manifest_module module ( ) Required Implementation of the Membrane.HTTPAdaptiveStream.Manifest behaviour. storage Storage . config_t ( ) Required Storage configuration. May be one of Membrane.HTTPAdaptiveStream.Storages.* . See Membrane.HTTPAdaptiveStream.Storage behaviour. target_window_duration Membrane.Time . t ( ) | :infinity Default value: 40000000000 Manifest duration is keept above that time, while the oldest segments are removed whenever possible. persist? boolean ( ) Default value: false If true, stale segments are removed from the manifest only. Once playback finishes, they are put back into the manifest. mode :live | :vod Default value: :vod Tells if the session is live or a VOD type of broadcast. It can influence type of metadata inserted into the playlist's manifest. header_naming_fun ( Manifest.Track . t ( ) , counter :: non_neg_integer -&gt; String . t ( ) ) Default value: &amp;Membrane.HTTPAdaptiveStream.Manifest.Track.default_header_naming_fun/2 A function that generates consequent header names for a given track. segment_naming_fun ( Manifest.Track . t ( ) -&gt; String . t ( ) ) Default value: &amp;Membrane.HTTPAdaptiveStream.Manifest.Track.default_segment_naming_fun/1 A function that generates consequent segment names for a given track. cleanup_after nil | Membrane.Time . t ( ) Default value: nil If not nil , time after a storage cleanup function should run. The function will remove all manifests and segments stored during the stream. Pads :input Accepted formats: CMAF.Track Direction: :input Availability: :on_request Mode: :pull Demand mode: :manual Demand unit: :buffers Pad options: track_name String . t ( ) | nil Default value: nil Name that will be used to name the media playlist for the given track, as well as its header and segments files. It must not contain any URI reserved characters. segment_duration SegmentDuration . t ( ) Required The expected minimum and target duration of media segments produced by this particular track. In case of regular paced streams the parameter may not have any impact, but when partial segments gets used it may decide when regular segments gets finalized and new gets started. target_partial_segment_duration Membrane.Time . t ( ) | nil Default value: nil The target duration of partial segments. When set to nil then the track is not supposed to emit partial segments.","ref":"Membrane.HTTPAdaptiveStream.Sink.html","title":"Membrane.HTTPAdaptiveStream.Sink","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.HTTPAdaptiveStream.Sink.html#options/0","title":"Membrane.HTTPAdaptiveStream.Sink.options/0","type":"function"},{"doc":"Options for pad :input","ref":"Membrane.HTTPAdaptiveStream.Sink.html#t:input_pad_opts_t/0","title":"Membrane.HTTPAdaptiveStream.Sink.input_pad_opts_t/0","type":"type"},{"doc":"Struct containing options for Membrane.HTTPAdaptiveStream.Sink","ref":"Membrane.HTTPAdaptiveStream.Sink.html#t:t/0","title":"Membrane.HTTPAdaptiveStream.Sink.t/0","type":"type"},{"doc":"Module representing a segment duration range that should appear in a playlist. The minimum and target durations are relevant if sink is set to work in low latency mode as the durations of partial segment can greatly vary.","ref":"Membrane.HTTPAdaptiveStream.Sink.SegmentDuration.html","title":"Membrane.HTTPAdaptiveStream.Sink.SegmentDuration","type":"module"},{"doc":"Creates a new segment duration with a target duration. The minimum duration is set to the target one.","ref":"Membrane.HTTPAdaptiveStream.Sink.SegmentDuration.html#new/1","title":"Membrane.HTTPAdaptiveStream.Sink.SegmentDuration.new/1","type":"function"},{"doc":"Creates a new segment duration with a minimum and target duration.","ref":"Membrane.HTTPAdaptiveStream.Sink.SegmentDuration.html#new/2","title":"Membrane.HTTPAdaptiveStream.Sink.SegmentDuration.new/2","type":"function"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Sink.SegmentDuration.html#t:t/0","title":"Membrane.HTTPAdaptiveStream.Sink.SegmentDuration.t/0","type":"type"},{"doc":"Bin responsible for receiving audio and video streams, performing payloading and CMAF muxing to eventually store them using provided storage configuration. Input streams Parsed H264 or AAC video or audio streams are expected to be connected via the :input pad. The type of stream has to be specified via the pad's :encoding option. Output Specify one of Membrane.HTTPAdaptiveStream.Storages as :storage to configure the sink. Bin options Passed via struct Membrane.HTTPAdaptiveStream.SinkBin.t/0 manifest_name String . t ( ) Default value: &quot;index&quot; Name of the main manifest file manifest_module module Required Implementation of the Membrane.HTTPAdaptiveStream.Manifest behaviour. storage Storage . config_t ( ) Required Storage configuration. May be one of Membrane.HTTPAdaptiveStream.Storages.* . See Membrane.HTTPAdaptiveStream.Storage behaviour. target_window_duration pos_integer | :infinity Default value: 40000000000 Manifest duration is kept above that time, while the oldest segments are removed whenever possible. persist? boolean Default value: false If true, stale segments are removed from the manifest only. Once playback finishes, they are put back into the manifest. mode :live | :vod Default value: :vod Tells if the session is live or a VOD type of broadcast. It can influence type of metadata inserted into the playlist's manifest. hls_mode :muxed_av | :separate_av Default value: :separate_av Option defining how the incoming tracks will be handled and how CMAF will be muxed. In :muxed_av audio will be added to each video rendition, creating CMAF segments that contain both audio and video. In :separate_av audio and video tracks will be separate and synchronization will need to be sorted out by the player. header_naming_fun ( Manifest.Track . t ( ) , counter :: non_neg_integer ( ) -&gt; String . t ( ) ) Default value: &amp;Membrane.HTTPAdaptiveStream.Manifest.Track.default_header_naming_fun/2 A function that generates consequent media header names for a given track segment_naming_fun ( Manifest.Track . t ( ) -&gt; String . t ( ) ) Default value: &amp;Membrane.HTTPAdaptiveStream.Manifest.Track.default_segment_naming_fun/1 A function that generates consequent segment names for a given track mp4_parameters_in_band? boolean ( ) Default value: false Determines whether the parameter type nalus will be removed from the stream. Inband parameters seem to be legal with MP4, but some players don't respond kindly to them, so use at your own risk. This parameter should be set to true when discontinuity can occur. For example when resolution can change. cleanup_after nil | Membrane.Time . t ( ) Default value: nil Time after which a fire-and-forget storage cleanup function should run. The function will remove all manifests and segments stored during the stream. Pads :input Accepted formats: Membrane.AAC % Membrane.H264 { profile : profile } when profile in @accepted_h264_profiles Direction: :input Availability: :on_request Mode: :pull Demand unit: :buffers Pad options: encoding :AAC | :H264 Required Encoding type determining which payloader will be used for the given stream. For H264, the accepted profiles are :constrained_baseline, :baseline, :high. track_name String . t ( ) | nil Default value: nil Name that will be used to name the media playlist for the given track, as well as its header and segments files. It must not contain any URI reserved characters segment_duration Sink.SegmentDuration . t ( ) Required The segment duration range of the regular segments. partial_segment_duration Sink.SegmentDuration . t ( ) | nil Default value: nil The segment duration range of the partial segments. If not set then the bin won't produce any partial segments.","ref":"Membrane.HTTPAdaptiveStream.SinkBin.html","title":"Membrane.HTTPAdaptiveStream.SinkBin","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.HTTPAdaptiveStream.SinkBin.html#options/0","title":"Membrane.HTTPAdaptiveStream.SinkBin.options/0","type":"function"},{"doc":"Options for pad :input","ref":"Membrane.HTTPAdaptiveStream.SinkBin.html#t:input_pad_opts_t/0","title":"Membrane.HTTPAdaptiveStream.SinkBin.input_pad_opts_t/0","type":"type"},{"doc":"Struct containing options for Membrane.HTTPAdaptiveStream.SinkBin","ref":"Membrane.HTTPAdaptiveStream.SinkBin.html#t:t/0","title":"Membrane.HTTPAdaptiveStream.SinkBin.t/0","type":"type"},{"doc":"Membrane.HTTPAdaptiveStream.Manifest implementation for HTTP Live Streaming. Currently supports up to one audio and video stream.","ref":"Membrane.HTTPAdaptiveStream.HLS.html","title":"Membrane.HTTPAdaptiveStream.HLS","type":"module"},{"doc":"Generates EXTM3U playlist for the given manifest","ref":"Membrane.HTTPAdaptiveStream.HLS.html#serialize/1","title":"Membrane.HTTPAdaptiveStream.HLS.serialize/1","type":"function"},{"doc":"Implementation of Membrane.HTTPAdaptiveStream.Manifest.SegmentAttribute behaviour for HTTP Live Streaming","ref":"Membrane.HTTPAdaptiveStream.HLS.SegmentAttribute.html","title":"Membrane.HTTPAdaptiveStream.HLS.SegmentAttribute","type":"module"},{"doc":"Behaviour for manifest serialization.","ref":"Membrane.HTTPAdaptiveStream.Manifest.html","title":"Membrane.HTTPAdaptiveStream.Manifest","type":"behaviour"},{"doc":"Add a new partial segment to the track with given track_id . Partial segments gets appended to the latest regular segment until finalize_current_segment/2 gets called. After that, in order to add new partial segments one must add an incomplete segment (a regular segment with and option of complete? set to false).","ref":"Membrane.HTTPAdaptiveStream.Manifest.html#add_partial_segment/5","title":"Membrane.HTTPAdaptiveStream.Manifest.add_partial_segment/5","type":"function"},{"doc":"Add a new regular segment to the track with given track_id .","ref":"Membrane.HTTPAdaptiveStream.Manifest.html#add_segment/4","title":"Membrane.HTTPAdaptiveStream.Manifest.add_segment/4","type":"function"},{"doc":"Add a track to the manifest. Returns the name under which the header file should be stored.","ref":"Membrane.HTTPAdaptiveStream.Manifest.html#add_track/2","title":"Membrane.HTTPAdaptiveStream.Manifest.add_track/2","type":"function"},{"doc":"Returns all segments grouped by the track id.","ref":"Membrane.HTTPAdaptiveStream.Manifest.html#all_segments_per_track/1","title":"Membrane.HTTPAdaptiveStream.Manifest.all_segments_per_track/1","type":"function"},{"doc":"Append a discontinuity to the track. This will inform the player that eg. the parameters of the encoder changed and allow you to provide a new MP4 header. For details on discontinuities refer to RFC 8216 .","ref":"Membrane.HTTPAdaptiveStream.Manifest.html#discontinue_track/2","title":"Membrane.HTTPAdaptiveStream.Manifest.discontinue_track/2","type":"function"},{"doc":"Finalizes current segment of given track when serving partial segments.","ref":"Membrane.HTTPAdaptiveStream.Manifest.html#finalize_current_segment/2","title":"Membrane.HTTPAdaptiveStream.Manifest.finalize_current_segment/2","type":"function"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.html#finish/2","title":"Membrane.HTTPAdaptiveStream.Manifest.finish/2","type":"function"},{"doc":"Restores all the stale segments in all tracks. All the tracks must be configured to be persisted beforehand, otherwise this function will raise","ref":"Membrane.HTTPAdaptiveStream.Manifest.html#from_beginning/1","title":"Membrane.HTTPAdaptiveStream.Manifest.from_beginning/1","type":"function"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.html#has_track?/2","title":"Membrane.HTTPAdaptiveStream.Manifest.has_track?/2","type":"function"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.html#serialize/1","title":"Membrane.HTTPAdaptiveStream.Manifest.serialize/1","type":"function"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.html#c:serialize/1","title":"Membrane.HTTPAdaptiveStream.Manifest.serialize/1","type":"callback"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.html#t:serialized_manifest_t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.serialized_manifest_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.html#t:serialized_manifests_t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.serialized_manifests_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.html#t:t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.t/0","type":"type"},{"doc":"Structure representing a single manifest segment. It stores the following fields: name - the segment's name duration - the segment's total duration byte_size - the byte_size of the segment payload attributes - the meta attributes associated with the segment type - decides if the structure is a full segment that can exist on its own or if it hosts and awaits more partial segments parts - the partial segments making up the full segment","ref":"Membrane.HTTPAdaptiveStream.Manifest.Segment.html","title":"Membrane.HTTPAdaptiveStream.Manifest.Segment","type":"module"},{"doc":"Structure of partial segment. Attributes representing a partial segment: independent? - decides if a segment can be played on its own e.g. starts with a keyframe or is an audio sample duration - the duration of the partial segment attributes - the attributes for the particular partial segment","ref":"Membrane.HTTPAdaptiveStream.Manifest.Segment.html#t:partial_segment_t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.Segment.partial_segment_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.Segment.html#t:segment_duration_t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.Segment.segment_duration_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.Segment.html#t:t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.Segment.t/0","type":"type"},{"doc":"Determines if segment is full and independent or partial and consists of several partial segments.","ref":"Membrane.HTTPAdaptiveStream.Manifest.Segment.html#t:type_t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.Segment.type_t/0","type":"type"},{"doc":"Definition of Segment Attributes and behaviour for serializing them. This module should also contain macros for generating different types of attributes","ref":"Membrane.HTTPAdaptiveStream.Manifest.SegmentAttribute.html","title":"Membrane.HTTPAdaptiveStream.Manifest.SegmentAttribute","type":"behaviour"},{"doc":"Creates a definition of a discontinuity segment attribute.","ref":"Membrane.HTTPAdaptiveStream.Manifest.SegmentAttribute.html#discontinuity/2","title":"Membrane.HTTPAdaptiveStream.Manifest.SegmentAttribute.discontinuity/2","type":"macro"},{"doc":"Callback for serializing a segment attribute to a string. It is required for each implementation of this behavior.","ref":"Membrane.HTTPAdaptiveStream.Manifest.SegmentAttribute.html#c:serialize/1","title":"Membrane.HTTPAdaptiveStream.Manifest.SegmentAttribute.serialize/1","type":"callback"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.SegmentAttribute.html#t:segment_type_t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.SegmentAttribute.segment_type_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.SegmentAttribute.html#t:t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.SegmentAttribute.t/0","type":"type"},{"doc":"Struct representing a state of a single manifest track and functions to operate on it.","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html","title":"Membrane.HTTPAdaptiveStream.Manifest.Track","type":"module"},{"doc":"Append a partial segment to the current incomplete segment. The current segment is supposed to be of type :partial , meaning that it is still in a phase of gathering partial segments before being finalized into a full segment. There can only be a single such segment and it must be the last one.","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#add_partial_segment/4","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.add_partial_segment/4","type":"function"},{"doc":"Add a segment of given duration to the track. It is recommended not to pass discontinuity attribute manually but use discontinue/1 function instead.","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#add_segment/3","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.add_segment/3","type":"function"},{"doc":"Returns all segments present in the track, including stale segments.","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#all_segments/1","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.all_segments/1","type":"function"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#default_header_naming_fun/2","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.default_header_naming_fun/2","type":"function"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#default_segment_naming_fun/1","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.default_segment_naming_fun/1","type":"function"},{"doc":"Discontinue the track, indicating that parameters of the stream have changed. New header has to be stored under the returned filename. For details on discontinuity, please refer to RFC 8216 .","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#discontinue/1","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.discontinue/1","type":"function"},{"doc":"Finalize current segment. With low latency, a regular segments gets created gradually. Each partial segment gets appended to a regular one, if all parts are collected then the regular segment is said to be complete. This function aims to finalize the current (latest) segment that is still incomplete so it can live on its own and so a new segment can get started.","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#finalize_current_segment/1","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.finalize_current_segment/1","type":"function"},{"doc":"Marks the track as finished. After this action, it won't be possible to add any new segments to the track.","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#finish/1","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.finish/1","type":"function"},{"doc":"Return new track with all stale segments restored, resulting in playback of historic data. Only works with 'persist?' option enabled.","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#from_beginning/1","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.from_beginning/1","type":"function"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#new/1","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.new/1","type":"function"},{"doc":"Tells whether the track is able to produce partial media segments.","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#supports_partial_segments?/1","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.supports_partial_segments?/1","type":"function"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#t:id_t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.id_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#t:segment_byte_size_t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.segment_byte_size_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#t:segment_duration_t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.segment_duration_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#t:segment_opt_t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.segment_opt_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#t:segments_t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.segments_t/0","type":"type"},{"doc":"The struct representing a track. Consists of all the fields from Config.t and also: header_name - name of the header file current_seq_num - the number to identify the next segment current_discontinuity_seq_num - number of current discontinuity sequence. segments - segments' names and durations stale_segments - stale segments' names and durations, kept empty unless persist? is set to true stale_headers - stale headers' names, kept empty unless persist? is set to true finished? - determines whether the track is finished window_duration - current window duration discontinuities_counter - the number of discontinuities that happened so far next_segment_id - the sequence number of the next segment that will be generated","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.html#t:t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.t/0","type":"type"},{"doc":"Structure representing changes that has been applied to the track. What element has been added and what elements are to be removed.","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.Changeset.html","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.Changeset","type":"module"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.Changeset.html#t:element_type_t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.Changeset.element_type_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.Changeset.html#t:t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.Changeset.t/0","type":"type"},{"doc":"Track configuration.","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.Config.html","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.Config","type":"module"},{"doc":"Track configuration consists of the following fields: id - identifies the track, will be serialized and attached to names of manifests, headers and segments track_name - the name of the track, determines how manifest files will be named content_type - either audio or video header_extension - extension of the header file (for example .mp4 for CMAF) segment_extension - extension of the segment files (for example .m4s for CMAF) header_naming_fun - a function that generates consequent header names for a given track segment_naming_fun - a function that generates consequent segment names for a given track target_segment_duration - expected duration of each segment target_partial_segment_duration - expected duration of each partial segment, nil if not partial segments are expected target_window_duration - track manifest duration is kept above that time, while the oldest segments are removed whenever possible persist? - determines whether the entire track contents should be available after the streaming finishes","ref":"Membrane.HTTPAdaptiveStream.Manifest.Track.Config.html#t:t/0","title":"Membrane.HTTPAdaptiveStream.Manifest.Track.Config.t/0","type":"type"},{"doc":"Behaviour for storing manifests and stream segments.","ref":"Membrane.HTTPAdaptiveStream.Storage.html","title":"Membrane.HTTPAdaptiveStream.Storage","type":"behaviour"},{"doc":"Stores a new segment and removes stale ones.","ref":"Membrane.HTTPAdaptiveStream.Storage.html#apply_segment_changeset/4","title":"Membrane.HTTPAdaptiveStream.Storage.apply_segment_changeset/4","type":"function"},{"doc":"Removes all segments grouped by track.","ref":"Membrane.HTTPAdaptiveStream.Storage.html#clean_all_track_segments/2","title":"Membrane.HTTPAdaptiveStream.Storage.clean_all_track_segments/2","type":"function"},{"doc":"Removes all the saved segments and manifest for given id.","ref":"Membrane.HTTPAdaptiveStream.Storage.html#cleanup/3","title":"Membrane.HTTPAdaptiveStream.Storage.cleanup/3","type":"function"},{"doc":"Clears the manifest cache.","ref":"Membrane.HTTPAdaptiveStream.Storage.html#clear_cache/1","title":"Membrane.HTTPAdaptiveStream.Storage.clear_cache/1","type":"function"},{"doc":"Generates the storage state based on the configuration struct.","ref":"Membrane.HTTPAdaptiveStream.Storage.html#c:init/1","title":"Membrane.HTTPAdaptiveStream.Storage.init/1","type":"callback"},{"doc":"Initializes the storage. Accepts the following options: enable_cache - if true (default), manifests will be stored only if they've been changed","ref":"Membrane.HTTPAdaptiveStream.Storage.html#new/2","title":"Membrane.HTTPAdaptiveStream.Storage.new/2","type":"function"},{"doc":"Removes the resource. In case of removing a segment the storage should make sure to remove all previous partial segments with the same name. It is the user's responsibility to remember and distinguish between the partial segments.","ref":"Membrane.HTTPAdaptiveStream.Storage.html#c:remove/4","title":"Membrane.HTTPAdaptiveStream.Storage.remove/4","type":"callback"},{"doc":"Stores the resource on a storage. Gets the mode that should be used when writing to a file and type of the resource","ref":"Membrane.HTTPAdaptiveStream.Storage.html#c:store/6","title":"Membrane.HTTPAdaptiveStream.Storage.store/6","type":"callback"},{"doc":"Stores stream header file.","ref":"Membrane.HTTPAdaptiveStream.Storage.html#store_header/4","title":"Membrane.HTTPAdaptiveStream.Storage.store_header/4","type":"function"},{"doc":"Stores serialized manifest files","ref":"Membrane.HTTPAdaptiveStream.Storage.html#store_manifests/2","title":"Membrane.HTTPAdaptiveStream.Storage.store_manifests/2","type":"function"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Storage.html#t:callback_result_t/0","title":"Membrane.HTTPAdaptiveStream.Storage.callback_result_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Storage.html#t:config_t/0","title":"Membrane.HTTPAdaptiveStream.Storage.config_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Storage.html#t:metadata_t/0","title":"Membrane.HTTPAdaptiveStream.Storage.metadata_t/0","type":"type"},{"doc":"The identifier of a parent that the resource belongs to (the track identifier). It can either be a master or secondary playlist (a track playlist). In case of master playlist the identifier will be :master while for tracks it can be an arbitrary value.","ref":"Membrane.HTTPAdaptiveStream.Storage.html#t:parent_t/0","title":"Membrane.HTTPAdaptiveStream.Storage.parent_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Storage.html#t:partial_segment_metadata/0","title":"Membrane.HTTPAdaptiveStream.Storage.partial_segment_metadata/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Storage.html#t:segment_metadata_t/0","title":"Membrane.HTTPAdaptiveStream.Storage.segment_metadata_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Storage.html#t:state_t/0","title":"Membrane.HTTPAdaptiveStream.Storage.state_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Storage.html#t:t/0","title":"Membrane.HTTPAdaptiveStream.Storage.t/0","type":"opaque"},{"doc":"Membrane.HTTPAdaptiveStream.Storage implementation that saves the stream to files locally.","ref":"Membrane.HTTPAdaptiveStream.Storages.FileStorage.html","title":"Membrane.HTTPAdaptiveStream.Storages.FileStorage","type":"module"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Storages.FileStorage.html#t:t/0","title":"Membrane.HTTPAdaptiveStream.Storages.FileStorage.t/0","type":"type"},{"doc":"Membrane.HTTPAdaptiveStream.Storage implementation that issues a call or cast with a message_t/0 to given destination on each call to store/remove.","ref":"Membrane.HTTPAdaptiveStream.Storages.GenServerStorage.html","title":"Membrane.HTTPAdaptiveStream.Storages.GenServerStorage","type":"module"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Storages.GenServerStorage.html#t:message_t/0","title":"Membrane.HTTPAdaptiveStream.Storages.GenServerStorage.message_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Storages.GenServerStorage.html#t:remove_t/0","title":"Membrane.HTTPAdaptiveStream.Storages.GenServerStorage.remove_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Storages.GenServerStorage.html#t:store_t/0","title":"Membrane.HTTPAdaptiveStream.Storages.GenServerStorage.store_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Storages.GenServerStorage.html#t:t/0","title":"Membrane.HTTPAdaptiveStream.Storages.GenServerStorage.t/0","type":"type"},{"doc":"Membrane.HTTPAdaptiveStream.Storage implementation that sends a message_t/0 to given destination on each call to store/remove.","ref":"Membrane.HTTPAdaptiveStream.Storages.SendStorage.html","title":"Membrane.HTTPAdaptiveStream.Storages.SendStorage","type":"module"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Storages.SendStorage.html#t:message_t/0","title":"Membrane.HTTPAdaptiveStream.Storages.SendStorage.message_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Storages.SendStorage.html#t:remove_t/0","title":"Membrane.HTTPAdaptiveStream.Storages.SendStorage.remove_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Storages.SendStorage.html#t:store_t/0","title":"Membrane.HTTPAdaptiveStream.Storages.SendStorage.store_t/0","type":"type"},{"doc":"","ref":"Membrane.HTTPAdaptiveStream.Storages.SendStorage.html#t:t/0","title":"Membrane.HTTPAdaptiveStream.Storages.SendStorage.t/0","type":"type"},{"doc":"Plugin generating manifests for HTTP adaptive streaming protocols. Currently, only HTTP Live Streaming (HLS) is supported. In future, the support for MPEG-DASH is planned as well","ref":"readme.html","title":"Membrane HTTP Adaptive Streaming Plugin","type":"extras"},{"doc":"Add the following line to your deps in mix.exs . Run mix deps.get . { :membrane_http_adaptive_stream_plugin , &quot;~&gt; 0.10.1&quot; }","ref":"readme.html#installation","title":"Membrane HTTP Adaptive Streaming Plugin - Installation","type":"extras"},{"doc":"See test/membrane_http_adaptive_stream/integration_test/sink_bin_integration_test.exs pipeline for details on how to use HLS plugin and generate HLS playlists for example media tracks. Master and media playlists with related multimedia content that were generated via this pipeline are stored in test/membrane_http_adaptive_stream/integration_test/fixtures directory.","ref":"readme.html#usage-example","title":"Membrane HTTP Adaptive Streaming Plugin - Usage Example","type":"extras"},{"doc":"Copyright 2019, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Membrane HTTP Adaptive Streaming Plugin - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2018 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]